rawset(_G, "PIZZA_SearchObjective", {})
rawset(_G, "PIZZA_Numbah", 1)
freeslot("SPR_PZAR", "S_PIZZ_POINT", "MT_PIZZ_POINT", "MT_CASH", "S_CASH_GRAB")
mobjinfo[MT_PIZZ_POINT] = {
    doomednum = -1,
    spawnstate = S_PIZZ_POINT,
    spawnhealth = 1,
    speed = 0,
    radius = 24*FRACUNIT,
    height = FRACUNIT,
    dispoffset = 0,
    mass = 100,
    damage = 0,
    flags = MF_NOCLIPTHING|MF_RUNSPAWNFUNC|MF_SCENERY
}

states[S_PIZZ_POINT] = {SPR_PZAR, A, 2, nil, 0, 0, S_PIZZ_POINT}
addHook("MobjSpawn", function(mo)
    table.insert(PIZZA_SearchObjective, mo)
end, MT_CASH)
addHook("ThinkFrame", do
	PIZZA_Numbah = #PIZZA_SearchObjective
end)
addHook("PlayerThink", function(player)
    if player.valid
        if PIZZA_SearchObjective //Vent Arrows
            and displayplayer == player //local
                for i = 1, #PIZZA_SearchObjective
                    if PIZZA_SearchObjective[i] and PIZZA_SearchObjective[i].valid
                        local wherevent = R_PointToAngle2(player.mo.x, player.mo.y, PIZZA_SearchObjective[i].x, PIZZA_SearchObjective[i].y)
                        local gotox = FixedMul(50*FRACUNIT, cos(wherevent))
                        local gotoy = FixedMul(50*FRACUNIT, sin(wherevent))
                        local point = P_SpawnMobjFromMobj(player.mo, gotox, gotoy, 25*FRACUNIT+(FRACUNIT/100*i), MT_PIZZ_POINT)
                        point.fuse = 2
                        point.momx = player.mo.momx
                        point.momy = player.mo.momy
                        point.momz = player.mo.momz
                        point.flags2 = $|MF2_SPLAT
                        point.renderflags = $|RF_NOSPLATBILLBOARD
                        point.angle = wherevent
                        point.state = S_PIZZ_POINT
                        point.connect = i
                        point.point = wherevent
                        if player.mo.eflags & MFE_VERTICALFLIP 
                            //point.flags2 = $|MF2_OBJECTFLIP
                            //point.eflags = $|MFE_VERTICALFLIP
                            point.renderflags = $|RF_VERTICALFLIP
                            point.spriteyoffset = 20*FRACUNIT
                        else
                            point.renderflags = $ & ~RF_VERTICALFLIP
                            point.spriteyoffset = 0
                            //point.flags2 = $ & ~MF2_OBJECTFLIP
                            //point.eflags = $ & ~MFE_VERTICALFLIP
                        end
                        local wheredist = R_PointToDist2(player.mo.x, player.mo.y, PIZZA_SearchObjective[i].x, PIZZA_SearchObjective[i].y)
                        if wheredist >= 10000*FRACUNIT //Weird ass distance check
                            point.color = SKINCOLOR_WHITE
                        elseif     wheredist >= 7000*FRACUNIT
                            point.color = SKINCOLOR_SAPPHIRE
                        elseif wheredist >= 6000*FRACUNIT
                            point.color = SKINCOLOR_BLUE
                        elseif wheredist >= 5000*FRACUNIT
                            point.color = SKINCOLOR_COBALT
                        elseif wheredist >= 2500*FRACUNIT
                            point.color = SKINCOLOR_PASTEL
                        elseif wheredist >= 1000*FRACUNIT
                            point.color = SKINCOLOR_PURPLE
                        elseif wheredist >= 800*FRACUNIT
                            point.color = SKINCOLOR_SALMON
                        elseif wheredist >= 500*FRACUNIT
                            point.color = SKINCOLOR_RED
                        else
                            point.color = SKINCOLOR_CRIMSON
                        end
                        if player.mo.angle >= wherevent-5*ANG1 //Gonna be resorted to debug mode
                        and player.mo.angle <= wherevent+5*ANG1
                            point.colorized = true
                            point.color = SKINCOLOR_KETCHUP
                            if player.cmd.buttons & BT_CUSTOM3
                                PIZZA_SearchObjective[i].nosoft = TICRATE*5
                                P_TeleportMove(player.mo, PIZZA_SearchObjective[i].x, PIZZA_SearchObjective[i].y, PIZZA_SearchObjective[i].z)
                            end
                        end //
                    end
                end
            end
    end
end)